#include<stdio.h>
#include<algorithm>
using namespace std;
 
#define level first
#define index second
#define NMAX 100005
 
int n, k;
long long d[NMAX], answer;
pair<int, int> special_nodes[NMAX];
 
bool check(pair<int,int> node_A, pair<int, int> node_B) {
    int mask_change = (1 << n) - 1 - (1 << node_A.level) + (1 << node_B.level);
    return (node_A.index & mask_change) == ((node_B.index & mask_change));
}
 
int main () {
    freopen("fft2d.in","r",stdin);
    freopen("fft2d.out","w",stdout);
     
    scanf("%d%d",&n,&k); n--;
    for(int i = 1; i <= k; i++) {
        scanf("%d%d", &special_nodes[i].level, &special_nodes[i].index);
        special_nodes[i].level = n - special_nodes[i].level;
    }
     
    sort(special_nodes + 1, special_nodes + k + 1);
     
    answer = (1LL << (2 * n));
     
    for(int i = 1; i <= k; i++) {
        int num_up = ((1LL) << (n - special_nodes[i].level));
        d[i] = ((1LL) << special_nodes[i].level);
         
        for(int j = 1; j < i; j++) {
            if(check(special_nodes[i], special_nodes[j])) {
                d[i] -= d[j];
            }
        }
        answer -= d[i] * num_up;
    //  printf("(%d %d %d) %d %d\n", i, special_nodes[i].level, special_nodes[i].index, d[i], num_up);
    }
     
    printf("%lld\n", answer); 
     
    return 0;
}