// Bogdan Ciobanu
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

const int kMaxSize = 1e6;

int main() {
    ifstream cin("pscfft.in");
    ofstream cout("pscfft.out");

    int q; cin >> q;
    while (q--> 0) {
        int sigma, str_length; cin >> str_length >> sigma;
        vector<int> str(str_length);
        for (auto& it : str) {
            cin >> it;
        }
        int mx_length = str_length; 
        for (int i = 0; i < sigma; ++i) {
            if (mx_length * sigma > kMaxSize) {
                mx_length = kMaxSize;
                break;
            }

            mx_length *= sigma;
        }
        mx_length += str_length;

        vector<int> big_str(mx_length);
        for (int i = 0; i < mx_length; ++i) {
            big_str[i] = (big_str[i / sigma] + i) % sigma;
        }

        for (int i = 0; i < mx_length - str_length + 1; ++i) {
            int j = 0;
            while (j < str_length and big_str[i + j] == str[j]) {
                ++j;
            }

            if (j == str_length) {
                cout << i << '\n';
                goto next_iter;
            }
        }
        cout << -1 << '\n';
        next_iter:;
    }

    return 0;
}